import type { CodeKeywordDefinition, ErrorObject, KeywordErrorDefinition, SchemaMap } from "../../types";
import type KeywordCxt from "../../compile/context";
export declare type DependenciesError = ErrorObject<"dependencies", {
    property: string;
    missingProperty: string;
    depsCount: number;
    deps: string;
}>;
export declare const error: KeywordErrorDefinition;
declare const def: CodeKeywordDefinition;
export declare function validatePropertyDeps(cxt: KeywordCxt, propertyDeps?: {
    [x: string]: string[];
}): void;
export declare function validateSchemaDeps(cxt: KeywordCxt, schemaDeps?: SchemaMap): void;
export default def;
